]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - etc/rc.subr
Automatically run ntpd as non-root when possible.
[FreeBSD/FreeBSD.git] / etc / rc.subr
1 # $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 #
19 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29 # POSSIBILITY OF SUCH DAMAGE.
30 #
31 # rc.subr
32 #       functions used by various rc scripts
33 #
34
35 : ${RC_PID:=$$}; export RC_PID
36
37 #
38 #       Operating System dependent/independent variables
39 #
40
41 if [ -n "${_rc_subr_loaded}" ]; then
42         return
43 fi
44
45 _rc_subr_loaded="YES"
46
47 SYSCTL="/sbin/sysctl"
48 SYSCTL_N="${SYSCTL} -n"
49 SYSCTL_W="${SYSCTL}"
50 PROTECT="/usr/bin/protect"
51 ID="/usr/bin/id"
52 IDCMD="if [ -x $ID ]; then $ID -un; fi"
53 PS="/bin/ps -ww"
54 JID=0
55
56 #
57 #       functions
58 #       ---------
59
60 # list_vars pattern
61 #       List vars matching pattern.
62
63 list_vars()
64 {
65         set | { while read LINE; do
66                 var="${LINE%%=*}"
67                 case "$var" in
68                 "$LINE"|*[!a-zA-Z0-9_]*) continue ;;
69                 $1) echo $var
70                 esac
71         done; }
72 }
73
74 # set_rcvar [var] [defval] [desc]
75 #
76 #       Echo or define a rc.conf(5) variable name.  Global variable
77 #       $rcvars is used.
78 #
79 #       If no argument is specified, echo "${name}_enable".
80 #
81 #       If only a var is specified, echo "${var}_enable".
82 #
83 #       If var and defval are specified, the ${var} is defined as
84 #       rc.conf(5) variable and the default value is ${defvar}.  An
85 #       optional argument $desc can also be specified to add a
86 #       description for that.
87 #
88 set_rcvar()
89 {
90         local _var
91
92         case $# in
93         0)      echo ${name}_enable ;;
94         1)      echo ${1}_enable ;;
95         *)
96                 debug "set_rcvar: \$$1=$2 is added" \
97                     " as a rc.conf(5) variable."
98                 _var=$1
99                 rcvars="${rcvars# } $_var"
100                 eval ${_var}_defval=\"$2\"
101                 shift 2
102                 eval ${_var}_desc=\"$*\"
103         ;;
104         esac
105 }
106
107 # set_rcvar_obsolete oldvar [newvar] [msg]
108 #       Define obsolete variable.
109 #       Global variable $rcvars_obsolete is used.
110 #
111 set_rcvar_obsolete()
112 {
113         local _var
114         _var=$1
115         debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
116
117         rcvars_obsolete="${rcvars_obsolete# } $1"
118         eval ${1}_newvar=\"$2\"
119         shift 2
120         eval ${_var}_obsolete_msg=\"$*\"
121 }
122
123 #
124 # force_depend script [rcvar]
125 #       Force a service to start. Intended for use by services
126 #       to resolve dependency issues.
127 #       $1 - filename of script, in /etc/rc.d, to run
128 #       $2 - name of the script's rcvar (minus the _enable)
129 #
130 force_depend()
131 {
132         local _depend _dep_rcvar
133
134         _depend="$1"
135         _dep_rcvar="${2:-$1}_enable"
136
137         [ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
138             checkyesno $_dep_rcvar && return 0
139
140         /etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
141
142         info "${name} depends on ${_depend}, which will be forced to start."
143         if ! /etc/rc.d/${_depend} forcestart; then
144                 warn "Unable to force ${_depend}. It may already be running."
145                 return 1
146         fi
147 }
148
149 #
150 # checkyesno var
151 #       Test $1 variable, and warn if not set to YES or NO.
152 #       Return 0 if it's "yes" (et al), nonzero otherwise.
153 #
154 checkyesno()
155 {
156         eval _value=\$${1}
157         debug "checkyesno: $1 is set to $_value."
158         case $_value in
159
160                 #       "yes", "true", "on", or "1"
161         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
162                 return 0
163                 ;;
164
165                 #       "no", "false", "off", or "0"
166         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
167                 return 1
168                 ;;
169         *)
170                 warn "\$${1} is not set properly - see rc.conf(5)."
171                 return 1
172                 ;;
173         esac
174 }
175
176 #
177 # reverse_list list
178 #       print the list in reverse order
179 #
180 reverse_list()
181 {
182         _revlist=
183         for _revfile; do
184                 _revlist="$_revfile $_revlist"
185         done
186         echo $_revlist
187 }
188
189 # stop_boot always
190 #       If booting directly to multiuser or $always is enabled,
191 #       send SIGTERM to the parent (/etc/rc) to abort the boot.
192 #       Otherwise just exit.
193 #
194 stop_boot()
195 {
196         local always
197
198         case $1 in
199                 #       "yes", "true", "on", or "1"
200         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
201                 always=true
202                 ;;
203         *)
204                 always=false
205                 ;;
206         esac
207         if [ "$autoboot" = yes -o "$always" = true ]; then
208                 echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
209                 kill -TERM ${RC_PID}
210         fi
211         exit 1
212 }
213
214 #
215 # mount_critical_filesystems type
216 #       Go through the list of critical filesystems as provided in
217 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
218 #       each one to see if it is mounted, and if it is not, mounting it.
219 #
220 mount_critical_filesystems()
221 {
222         eval _fslist=\$critical_filesystems_${1}
223         for _fs in $_fslist; do
224                 mount | (
225                         _ismounted=false
226                         while read what _on on _type type; do
227                                 if [ $on = $_fs ]; then
228                                         _ismounted=true
229                                 fi
230                         done
231                         if $_ismounted; then
232                                 :
233                         else
234                                 mount $_fs >/dev/null 2>&1
235                         fi
236                 )
237         done
238 }
239
240 #
241 # check_pidfile pidfile procname [interpreter]
242 #       Parses the first line of pidfile for a PID, and ensures
243 #       that the process is running and matches procname.
244 #       Prints the matching PID upon success, nothing otherwise.
245 #       interpreter is optional; see _find_processes() for details.
246 #
247 check_pidfile()
248 {
249         _pidfile=$1
250         _procname=$2
251         _interpreter=$3
252         if [ -z "$_pidfile" -o -z "$_procname" ]; then
253                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
254         fi
255         if [ ! -f $_pidfile ]; then
256                 debug "pid file ($_pidfile): not readable."
257                 return
258         fi
259         read _pid _junk < $_pidfile
260         if [ -z "$_pid" ]; then
261                 debug "pid file ($_pidfile): no pid in file."
262                 return
263         fi
264         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
265 }
266
267 #
268 # check_process procname [interpreter]
269 #       Ensures that a process (or processes) named procname is running.
270 #       Prints a list of matching PIDs.
271 #       interpreter is optional; see _find_processes() for details.
272 #
273 check_process()
274 {
275         _procname=$1
276         _interpreter=$2
277         if [ -z "$_procname" ]; then
278                 err 3 'USAGE: check_process procname [interpreter]'
279         fi
280         _find_processes $_procname ${_interpreter:-.} '-ax'
281 }
282
283 #
284 # _find_processes procname interpreter psargs
285 #       Search for procname in the output of ps generated by psargs.
286 #       Prints the PIDs of any matching processes, space separated.
287 #
288 #       If interpreter == ".", check the following variations of procname
289 #       against the first word of each command:
290 #               procname
291 #               `basename procname`
292 #               `basename procname` + ":"
293 #               "(" + `basename procname` + ")"
294 #               "[" + `basename procname` + "]"
295 #
296 #       If interpreter != ".", read the first line of procname, remove the
297 #       leading #!, normalise whitespace, append procname, and attempt to
298 #       match that against each command, either as is, or with extra words
299 #       at the end.  As an alternative, to deal with interpreted daemons
300 #       using perl, the basename of the interpreter plus a colon is also
301 #       tried as the prefix to procname.
302 #
303 _find_processes()
304 {
305         if [ $# -ne 3 ]; then
306                 err 3 'USAGE: _find_processes procname interpreter psargs'
307         fi
308         _procname=$1
309         _interpreter=$2
310         _psargs=$3
311
312         _pref=
313         if [ $_interpreter != "." ]; then       # an interpreted script
314                 _script="${_chroot}${_chroot:+/}$_procname"
315                 if [ -r "$_script" ]; then
316                         read _interp < $_script # read interpreter name
317                         case "$_interp" in
318                         \#!*)
319                                 _interp=${_interp#\#!}  # strip #!
320                                 set -- $_interp
321                                 case $1 in
322                                 */bin/env)
323                                         shift   # drop env to get real name
324                                         ;;
325                                 esac
326                                 if [ $_interpreter != $1 ]; then
327                                         warn "\$command_interpreter $_interpreter != $1"
328                                 fi
329                                 ;;
330                         *)
331                                 warn "no shebang line in $_script"
332                                 set -- $_interpreter
333                                 ;;
334                         esac
335                 else
336                         warn "cannot read shebang line from $_script"
337                         set -- $_interpreter
338                 fi
339                 _interp="$* $_procname"         # cleanup spaces, add _procname
340                 _interpbn=${1##*/}
341                 _fp_args='_argv'
342                 _fp_match='case "$_argv" in
343                     ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
344         else                                    # a normal daemon
345                 _procnamebn=${_procname##*/}
346                 _fp_args='_arg0 _argv'
347                 _fp_match='case "$_arg0" in
348                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
349         fi
350
351         _proccheck="\
352                 $PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
353                 while read _npid _jid '"$_fp_args"'; do
354                         '"$_fp_match"'
355                                 if [ "$JID" -eq "$_jid" ];
356                                 then echo -n "$_pref$_npid";
357                                 _pref=" ";
358                                 fi
359                                 ;;
360                         esac
361                 done'
362
363 #       debug "in _find_processes: proccheck is ($_proccheck)."
364         eval $_proccheck
365 }
366
367 # sort_lite [-b] [-n] [-k POS] [-t SEP]
368 #       A lite version of sort(1) (supporting a few options) that can be used
369 #       before the real sort(1) is available (e.g., in scripts that run prior
370 #       to mountcritremote). Requires only shell built-in functionality.
371 #
372 sort_lite()
373 {
374         local funcname=sort_lite
375         local sort_sep="$IFS" sort_ignore_leading_space=
376         local sort_field=0 sort_strict_fields= sort_numeric=
377         local nitems=0 skip_leading=0 trim=
378
379         local OPTIND flag
380         while getopts bnk:t: flag; do
381                 case "$flag" in
382                 b) sort_ignore_leading_space=1 ;;
383                 n) sort_numeric=1 sort_ignore_leading_space=1 ;;
384                 k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
385                         # NB: Unlike sort(1) only one POS allowed
386                 t) sort_sep="$OPTARG"
387                    if [ ${#sort_sep} -gt 1 ]; then
388                         echo "$funcname: multi-character tab \`$sort_sep'" >&2
389                         return 1
390                    fi
391                    sort_strict_fields=1
392                    ;;
393                 \?) return 1 ;;
394                 esac
395         done
396         shift $(( $OPTIND - 1 ))
397
398         # Create transformation pattern to trim leading text if desired
399         case "$sort_field" in
400         ""|[!0-9]*|*[!0-9.]*)
401                 echo "$funcname: invalid sort field \`$sort_field'" >&2
402                 return 1
403                 ;;
404         *.*)
405                 skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
406                 while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
407                         trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
408                 done
409         esac
410
411         # Copy input to series of local numbered variables
412         # NB: IFS of NULL preserves leading whitespace
413         local LINE
414         while IFS= read -r LINE || [ "$LINE" ]; do
415                 nitems=$(( $nitems + 1 ))
416                 local src_$nitems="$LINE"
417         done
418
419         #
420         # Sort numbered locals using insertion sort
421         #
422         local curitem curitem_orig curitem_mod curitem_haskey
423         local dest dest_orig dest_mod dest_haskey
424         local d gt n
425         local i=1 
426         while [ $i -le $nitems ]; do
427                 curitem_haskey=1 # Assume sort field (-k POS) exists
428                 eval curitem=\"\$src_$i\"
429                 curitem_mod="$curitem" # for modified comparison
430                 curitem_orig="$curitem" # for original comparison
431
432                 # Trim leading whitespace if desired
433                 if [ "$sort_ignore_leading_space" ]; then
434                         while case "$curitem_orig" in
435                                 [$IFS]*) : ;; *) false; esac
436                         do
437                                 curitem_orig="${curitem_orig#?}"
438                         done
439                         curitem_mod="$curitem_orig"
440                 fi
441
442                 # Shift modified comparison value if sort field (-k POS) is > 1
443                 n=$sort_field
444                 while [ $n -gt 1 ]; do
445                         case "$curitem_mod" in
446                         *[$sort_sep]*)
447                                 # Cut text up-to (and incl.) first separator
448                                 curitem_mod="${curitem_mod#*[$sort_sep]}"
449
450                                 # Skip NULLs unless strict field splitting
451                                 [ "$sort_strict_fields" ] ||
452                                         [ "${curitem_mod%%[$sort_sep]*}" ] ||
453                                         [ $n -eq 2 ] ||
454                                         continue
455                                 ;;
456                         *)
457                                 # Asked for a field that doesn't exist
458                                 curitem_haskey= break
459                         esac
460                         n=$(( $n - 1 ))
461                 done
462
463                 # Trim trailing words if sort field >= 1
464                 [ $sort_field -ge 1 -a "$sort_numeric" ] &&
465                         curitem_mod="${curitem_mod%%[$sort_sep]*}"
466
467                 # Apply optional trim (-k POS.TRIM) to cut leading characters
468                 curitem_mod="${curitem_mod#$trim}"
469
470                 # Determine the type of modified comparison to use initially
471                 # NB: Prefer numerical if requested but fallback to standard
472                 case "$curitem_mod" in
473                 ""|[!0-9]*) # NULL or begins with non-number
474                         gt=">"
475                         [ "$sort_numeric" ] && curitem_mod=0
476                         ;;
477                 *)
478                         if [ "$sort_numeric" ]; then
479                                 gt="-gt"
480                                 curitem_mod="${curitem_mod%%[!0-9]*}"
481                                         # NB: trailing non-digits removed
482                                         # otherwise numeric comparison fails
483                         else
484                                 gt=">"
485                         fi
486                 esac
487
488                 # If first time through, short-circuit below position-search
489                 if [ $i -le 1 ]; then
490                         d=0
491                 else
492                         d=1
493                 fi
494
495                 #
496                 # Find appropriate element position
497                 #
498                 while [ $d -gt 0 ]
499                 do
500                         dest_haskey=$curitem_haskey
501                         eval dest=\"\$dest_$d\"
502                         dest_mod="$dest" # for modified comparison
503                         dest_orig="$dest" # for original comparison
504
505                         # Trim leading whitespace if desired
506                         if [ "$sort_ignore_leading_space" ]; then
507                                 while case "$dest_orig" in
508                                         [$IFS]*) : ;; *) false; esac
509                                 do
510                                         dest_orig="${dest_orig#?}"
511                                 done
512                                 dest_mod="$dest_orig"
513                         fi
514
515                         # Shift modified value if sort field (-k POS) is > 1
516                         n=$sort_field
517                         while [ $n -gt 1 ]; do
518                                 case "$dest_mod" in
519                                 *[$sort_sep]*)
520                                         # Cut text up-to (and incl.) 1st sep
521                                         dest_mod="${dest_mod#*[$sort_sep]}"
522
523                                         # Skip NULLs unless strict fields
524                                         [ "$sort_strict_fields" ] ||
525                                             [ "${dest_mod%%[$sort_sep]*}" ] ||
526                                             [ $n -eq 2 ] ||
527                                             continue
528                                         ;;
529                                 *)
530                                         # Asked for a field that doesn't exist
531                                         dest_haskey= break
532                                 esac
533                                 n=$(( $n - 1 ))
534                         done
535
536                         # Trim trailing words if sort field >= 1
537                         [ $sort_field -ge 1 -a "$sort_numeric" ] &&
538                                 dest_mod="${dest_mod%%[$sort_sep]*}"
539
540                         # Apply optional trim (-k POS.TRIM), cut leading chars
541                         dest_mod="${dest_mod#$trim}"
542
543                         # Determine type of modified comparison to use
544                         # NB: Prefer numerical if requested, fallback to std
545                         case "$dest_mod" in
546                         ""|[!0-9]*) # NULL or begins with non-number
547                                 gt=">"
548                                 [ "$sort_numeric" ] && dest_mod=0
549                                 ;;
550                         *)
551                                 if [ "$sort_numeric" ]; then
552                                         gt="-gt"
553                                         dest_mod="${dest_mod%%[!0-9]*}"
554                                                 # NB: kill trailing non-digits
555                                                 # for numeric comparison safety
556                                 else
557                                         gt=">"
558                                 fi
559                         esac
560
561                         # Break if we've found the proper element position
562                         if [ "$curitem_haskey" -a "$dest_haskey" ]; then
563                                 if [ "$dest_mod" = "$curitem_mod" ]; then
564                                         [ "$dest_orig" ">" "$curitem_orig" ] &&
565                                                 break
566                                 elif [ "$dest_mod" $gt "$curitem_mod" ] \
567                                         2> /dev/null
568                                 then
569                                         break
570                                 fi
571                         else
572                                 [ "$dest_orig" ">" "$curitem_orig" ] && break
573                         fi
574
575                         # Break if we've hit the end
576                         [ $d -ge $i ] && break
577
578                         d=$(( $d + 1 ))
579                 done
580
581                 # Shift remaining positions forward, making room for new item
582                 n=$i
583                 while [ $n -ge $d ]; do
584                         # Shift destination item forward one placement
585                         eval dest_$(( $n + 1 ))=\"\$dest_$n\"
586                         n=$(( $n - 1 ))
587                 done
588
589                 # Place the element
590                 if [ $i -eq 1 ]; then
591                         local dest_1="$curitem"
592                 else
593                         local dest_$d="$curitem"
594                 fi
595
596                 i=$(( $i + 1 ))
597         done
598
599         # Print sorted results
600         d=1
601         while [ $d -le $nitems ]; do
602                 eval echo \"\$dest_$d\"
603                 d=$(( $d + 1 ))
604         done
605 }
606
607 #
608 # wait_for_pids pid [pid ...]
609 #       spins until none of the pids exist
610 #
611 wait_for_pids()
612 {
613         local _list _prefix _nlist _j
614
615         _list="$@"
616         if [ -z "$_list" ]; then
617                 return
618         fi
619         _prefix=
620         while true; do
621                 _nlist="";
622                 for _j in $_list; do
623                         if kill -0 $_j 2>/dev/null; then
624                                 _nlist="${_nlist}${_nlist:+ }$_j"
625                                 [ -n "$_prefix" ] && sleep 1
626                         fi
627                 done
628                 if [ -z "$_nlist" ]; then
629                         break
630                 fi
631                 _list=$_nlist
632                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
633                 _prefix=", "
634                 pwait $_list 2>/dev/null
635         done
636         if [ -n "$_prefix" ]; then
637                 echo "."
638         fi
639 }
640
641 #
642 # get_pidfile_from_conf string file
643 #
644 #       Takes a string to search for in the specified file.
645 #       Ignores lines with traditional comment characters.
646 #
647 # Example:
648 #
649 # if get_pidfile_from_conf string file; then
650 #       pidfile="$_pidfile_from_conf"
651 # else
652 #       pidfile='appropriate default'
653 # fi
654 #
655 get_pidfile_from_conf()
656 {
657         if [ -z "$1" -o -z "$2" ]; then
658                 err 3 "USAGE: get_pidfile_from_conf string file ($name)"
659         fi
660
661         local string file line
662
663         string="$1" ; file="$2"
664
665         if [ ! -s "$file" ]; then
666                 err 3 "get_pidfile_from_conf: $file does not exist ($name)"
667         fi
668
669         while read line; do
670                 case "$line" in
671                 *[#\;]*${string}*)      continue ;;
672                 *${string}*)            break ;;
673                 esac
674         done < $file
675
676         if [ -n "$line" ]; then
677                 line=${line#*/}
678                 _pidfile_from_conf="/${line%%[\"\;]*}"
679         else
680                 return 1
681         fi
682 }
683
684 #
685 # check_startmsgs
686 #       If rc_quiet is set (usually as a result of using faststart at
687 #       boot time) check if rc_startmsgs is enabled.
688 #
689 check_startmsgs()
690 {
691         if [ -n "$rc_quiet" ]; then
692                 checkyesno rc_startmsgs
693         else
694                 return 0
695         fi
696 }
697
698 #
699 # run_rc_command argument
700 #       Search for argument in the list of supported commands, which is:
701 #               "start stop restart rcvar status poll ${extra_commands}"
702 #       If there's a match, run ${argument}_cmd or the default method
703 #       (see below).
704 #
705 #       If argument has a given prefix, then change the operation as follows:
706 #               Prefix  Operation
707 #               ------  ---------
708 #               fast    Skip the pid check, and set rc_fast=yes, rc_quiet=yes
709 #               force   Set ${rcvar} to YES, and set rc_force=yes
710 #               one     Set ${rcvar} to YES
711 #               quiet   Don't output some diagnostics, and set rc_quiet=yes
712 #
713 #       The following globals are used:
714 #
715 #       Name            Needed  Purpose
716 #       ----            ------  -------
717 #       name            y       Name of script.
718 #
719 #       command         n       Full path to command.
720 #                               Not needed if ${rc_arg}_cmd is set for
721 #                               each keyword.
722 #
723 #       command_args    n       Optional args/shell directives for command.
724 #
725 #       command_interpreter n   If not empty, command is interpreted, so
726 #                               call check_{pidfile,process}() appropriately.
727 #
728 #       desc            n       Description of script.
729 #
730 #       extra_commands  n       List of extra commands supported.
731 #
732 #       pidfile         n       If set, use check_pidfile $pidfile $command,
733 #                               otherwise use check_process $command.
734 #                               In either case, only check if $command is set.
735 #
736 #       procname        n       Process name to check for instead of $command.
737 #
738 #       rcvar           n       This is checked with checkyesno to determine
739 #                               if the action should be run.
740 #
741 #       ${name}_program n       Full path to command.
742 #                               Meant to be used in /etc/rc.conf to override
743 #                               ${command}.
744 #
745 #       ${name}_chroot  n       Directory to chroot to before running ${command}
746 #                               Requires /usr to be mounted.
747 #
748 #       ${name}_chdir   n       Directory to cd to before running ${command}
749 #                               (if not using ${name}_chroot).
750 #
751 #       ${name}_flags   n       Arguments to call ${command} with.
752 #                               NOTE:   $flags from the parent environment
753 #                                       can be used to override this.
754 #
755 #       ${name}_env     n       Environment variables to run ${command} with.
756 #
757 #       ${name}_env_file n      File to source variables to run ${command} with.
758 #
759 #       ${name}_fib     n       Routing table number to run ${command} with.
760 #
761 #       ${name}_nice    n       Nice level to run ${command} at.
762 #
763 #       ${name}_oomprotect n    Don't kill ${command} when swap space is exhausted.
764 #
765 #       ${name}_user    n       User to run ${command} as, using su(1) if not
766 #                               using ${name}_chroot.
767 #                               Requires /usr to be mounted.
768 #
769 #       ${name}_group   n       Group to run chrooted ${command} as.
770 #                               Requires /usr to be mounted.
771 #
772 #       ${name}_groups  n       Comma separated list of supplementary groups
773 #                               to run the chrooted ${command} with.
774 #                               Requires /usr to be mounted.
775 #
776 #       ${name}_prepend n       Command added before ${command}.
777 #
778 #       ${name}_login_class n   Login class to use, else "daemon".
779 #
780 #       ${name}_limits  n       limits(1) to apply to ${command}.
781 #
782 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
783 #                               Otherwise, use default command (see below)
784 #
785 #       ${rc_arg}_precmd n      If set, run just before performing the
786 #                               ${rc_arg}_cmd method in the default
787 #                               operation (i.e, after checking for required
788 #                               bits and process (non)existence).
789 #                               If this completes with a non-zero exit code,
790 #                               don't run ${rc_arg}_cmd.
791 #
792 #       ${rc_arg}_postcmd n     If set, run just after performing the
793 #                               ${rc_arg}_cmd method, if that method
794 #                               returned a zero exit code.
795 #
796 #       required_dirs   n       If set, check for the existence of the given
797 #                               directories before running a (re)start command.
798 #
799 #       required_files  n       If set, check for the readability of the given
800 #                               files before running a (re)start command.
801 #
802 #       required_modules n      If set, ensure the given kernel modules are
803 #                               loaded before running a (re)start command.
804 #                               The check and possible loads are actually
805 #                               done after start_precmd so that the modules
806 #                               aren't loaded in vain, should the precmd
807 #                               return a non-zero status to indicate a error.
808 #                               If a word in the list looks like "foo:bar",
809 #                               "foo" is the KLD file name and "bar" is the
810 #                               module name.  If a word looks like "foo~bar",
811 #                               "foo" is the KLD file name and "bar" is a
812 #                               egrep(1) pattern matching the module name.
813 #                               Otherwise the module name is assumed to be
814 #                               the same as the KLD file name, which is most
815 #                               common.  See load_kld().
816 #
817 #       required_vars   n       If set, perform checkyesno on each of the
818 #                               listed variables before running the default
819 #                               (re)start command.
820 #
821 #       Default behaviour for a given argument, if no override method is
822 #       provided:
823 #
824 #       Argument        Default behaviour
825 #       --------        -----------------
826 #       start           if !running && checkyesno ${rcvar}
827 #                               ${command}
828 #
829 #       stop            if ${pidfile}
830 #                               rc_pid=$(check_pidfile $pidfile $command)
831 #                       else
832 #                               rc_pid=$(check_process $command)
833 #                       kill $sig_stop $rc_pid
834 #                       wait_for_pids $rc_pid
835 #                       ($sig_stop defaults to TERM.)
836 #
837 #       reload          Similar to stop, except use $sig_reload instead,
838 #                       and doesn't wait_for_pids.
839 #                       $sig_reload defaults to HUP.
840 #                       Note that `reload' isn't provided by default,
841 #                       it should be enabled via $extra_commands.
842 #
843 #       restart         Run `stop' then `start'.
844 #
845 #       status          Show if ${command} is running, etc.
846 #
847 #       poll            Wait for ${command} to exit.
848 #
849 #       rcvar           Display what rc.conf variable is used (if any).
850 #
851 #       enabled         Return true if the service is enabled.
852 #
853 #       describe        Show the service's description
854 #
855 #       extracommands   Show the service's extra commands
856 #
857 #       Variables available to methods, and after run_rc_command() has
858 #       completed:
859 #
860 #       Variable        Purpose
861 #       --------        -------
862 #       rc_arg          Argument to command, after fast/force/one processing
863 #                       performed
864 #
865 #       rc_flags        Flags to start the default command with.
866 #                       Defaults to ${name}_flags, unless overridden
867 #                       by $flags from the environment.
868 #                       This variable may be changed by the precmd method.
869 #
870 #       rc_pid          PID of command (if appropriate)
871 #
872 #       rc_fast         Not empty if "fast" was provided (q.v.)
873 #
874 #       rc_force        Not empty if "force" was provided (q.v.)
875 #
876 #       rc_quiet        Not empty if "quiet" was provided
877 #
878 #
879 run_rc_command()
880 {
881         _return=0
882         rc_arg=$1
883         if [ -z "$name" ]; then
884                 err 3 'run_rc_command: $name is not set.'
885         fi
886
887         # Don't repeat the first argument when passing additional command-
888         # line arguments to the command subroutines.
889         #
890         shift 1
891         rc_extra_args="$*"
892
893         _rc_prefix=
894         case "$rc_arg" in
895         fast*)                          # "fast" prefix; don't check pid
896                 rc_arg=${rc_arg#fast}
897                 rc_fast=yes
898                 rc_quiet=yes
899                 ;;
900         force*)                         # "force" prefix; always run
901                 rc_force=yes
902                 _rc_prefix=force
903                 rc_arg=${rc_arg#${_rc_prefix}}
904                 if [ -n "${rcvar}" ]; then
905                         eval ${rcvar}=YES
906                 fi
907                 ;;
908         one*)                           # "one" prefix; set ${rcvar}=yes
909                 _rc_prefix=one
910                 rc_arg=${rc_arg#${_rc_prefix}}
911                 if [ -n "${rcvar}" ]; then
912                         eval ${rcvar}=YES
913                 fi
914                 ;;
915         quiet*)                         # "quiet" prefix; omit some messages
916                 _rc_prefix=quiet
917                 rc_arg=${rc_arg#${_rc_prefix}}
918                 rc_quiet=yes
919                 ;;
920         esac
921
922         eval _override_command=\$${name}_program
923         command=${_override_command:-$command}
924
925         _keywords="start stop restart rcvar enabled describe extracommands $extra_commands"
926         rc_pid=
927         _pidcmd=
928         _procname=${procname:-${command}}
929
930                                         # setup pid check command
931         if [ -n "$_procname" ]; then
932                 if [ -n "$pidfile" ]; then
933                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
934                 else
935                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
936                 fi
937                 _keywords="${_keywords} status poll"
938         fi
939
940         if [ -z "$rc_arg" ]; then
941                 rc_usage $_keywords
942         fi
943
944         if [ "$rc_arg" = "enabled" ] ; then
945                 checkyesno ${rcvar}
946                 return $?
947         fi
948
949         if [ -n "$flags" ]; then        # allow override from environment
950                 rc_flags=$flags
951         else
952                 eval rc_flags=\$${name}_flags
953         fi
954         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
955             _nice=\$${name}_nice        _user=\$${name}_user \
956             _group=\$${name}_group      _groups=\$${name}_groups \
957             _fib=\$${name}_fib          _env=\$${name}_env \
958             _prepend=\$${name}_prepend  _login_class=\${${name}_login_class:-daemon} \
959             _limits=\$${name}_limits    _oomprotect=\$${name}_oomprotect \
960             _env_file=\$${name}_env_file
961
962         if [ -n "$_env_file" ] && [ -r "${_env_file}" ]; then   # load env from file
963                 set -a
964                 . $_env_file
965                 set +a
966         fi
967
968         if [ -n "$_user" ]; then        # unset $_user if running as that user
969                 if [ "$_user" = "$(eval $IDCMD)" ]; then
970                         unset _user
971                 fi
972         fi
973
974         [ -z "$autoboot" ] && eval $_pidcmd     # determine the pid if necessary
975
976         for _elem in $_keywords; do
977                 if [ "$_elem" != "$rc_arg" ]; then
978                         continue
979                 fi
980                                         # if ${rcvar} is set, $1 is not "rcvar" and not "describe"
981                                         # and ${rc_pid} is not set, then run
982                                         #       checkyesno ${rcvar}
983                                         # and return if that failed
984                                         #
985                 if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" \
986                     -a "$rc_arg" != "describe" ] ||
987                     [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
988                         if ! checkyesno ${rcvar}; then
989                                 if [ -n "${rc_quiet}" ]; then
990                                         return 0
991                                 fi
992                                 echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
993                                 echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
994                                 echo "instead of '${rc_arg}'."
995                                 return 0
996                         fi
997                 fi
998
999                 if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
1000                         if [ -z "$rc_quiet" ]; then
1001                                 echo 1>&2 "${name} already running? " \
1002                                     "(pid=$rc_pid)."
1003                         fi
1004                         return 1
1005                 fi
1006
1007                                         # if there's a custom ${XXX_cmd},
1008                                         # run that instead of the default
1009                                         #
1010                 eval _cmd=\$${rc_arg}_cmd \
1011                      _precmd=\$${rc_arg}_precmd \
1012                      _postcmd=\$${rc_arg}_postcmd
1013
1014                 if [ -n "$_cmd" ]; then
1015                         _run_rc_precmd || return 1
1016                         _run_rc_doit "$_cmd $rc_extra_args" || return 1
1017                         _run_rc_postcmd
1018                         return $_return
1019                 fi
1020
1021                 case "$rc_arg" in       # default operations...
1022
1023                 describe)
1024                         if [ -n "$desc" ]; then
1025                                 echo "$desc"
1026                         fi
1027                         ;;
1028         
1029                 extracommands)
1030                         echo "$extra_commands"
1031                         ;;
1032
1033                 status)
1034                         _run_rc_precmd || return 1
1035                         if [ -n "$rc_pid" ]; then
1036                                 echo "${name} is running as pid $rc_pid."
1037                         else
1038                                 echo "${name} is not running."
1039                                 return 1
1040                         fi
1041                         _run_rc_postcmd
1042                         ;;
1043
1044                 start)
1045                         if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1046                                 warn "run_rc_command: cannot run $command"
1047                                 return 1
1048                         fi
1049
1050                         if ! _run_rc_precmd; then
1051                                 warn "failed precmd routine for ${name}"
1052                                 return 1
1053                         fi
1054
1055                                         # setup the full command to run
1056                                         #
1057                         check_startmsgs && echo "Starting ${name}."
1058                         if [ -n "$_chroot" ]; then
1059                                 _cd=
1060                                 _doit="\
1061 ${_nice:+nice -n $_nice }\
1062 ${_fib:+setfib -F $_fib }\
1063 ${_env:+env $_env }\
1064 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1065 $_chroot $command $rc_flags $command_args"
1066                         else
1067                                 _cd="${_chdir:+cd $_chdir && }"
1068                                 _doit="\
1069 ${_fib:+setfib -F $_fib }\
1070 ${_env:+env $_env }\
1071 $command $rc_flags $command_args"
1072                                 if [ -n "$_user" ]; then
1073                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1074                                 fi
1075                                 if [ -n "$_nice" ]; then
1076                                         if [ -z "$_user" ]; then
1077                                                 _doit="sh -c \"$_doit\""
1078                                         fi
1079                                         _doit="nice -n $_nice $_doit"
1080                                 fi
1081                                 if [ -n "$_prepend" ]; then
1082                                         _doit="$_prepend $_doit"
1083                                 fi
1084                         fi
1085
1086                                         # Prepend default limits
1087                         _doit="$_cd limits -C $_login_class $_limits $_doit"
1088
1089                                         # run the full command
1090                                         #
1091                         if ! _run_rc_doit "$_doit"; then
1092                                 warn "failed to start ${name}"
1093                                 return 1
1094                         fi
1095
1096                                         # finally, run postcmd
1097                                         #
1098                         _run_rc_postcmd
1099                         ;;
1100
1101                 stop)
1102                         if [ -z "$rc_pid" ]; then
1103                                 [ -n "$rc_fast" ] && return 0
1104                                 _run_rc_notrunning
1105                                 return 1
1106                         fi
1107
1108                         _run_rc_precmd || return 1
1109
1110                                         # send the signal to stop
1111                                         #
1112                         echo "Stopping ${name}."
1113                         _doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1114                         _run_rc_doit "$_doit" || return 1
1115
1116                                         # wait for the command to exit,
1117                                         # and run postcmd.
1118                         wait_for_pids $rc_pid
1119
1120                         _run_rc_postcmd
1121                         ;;
1122
1123                 reload)
1124                         if [ -z "$rc_pid" ]; then
1125                                 _run_rc_notrunning
1126                                 return 1
1127                         fi
1128
1129                         _run_rc_precmd || return 1
1130
1131                         _doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1132                         _run_rc_doit "$_doit" || return 1
1133
1134                         _run_rc_postcmd
1135                         ;;
1136
1137                 restart)
1138                                         # prevent restart being called more
1139                                         # than once by any given script
1140                                         #
1141                         if ${_rc_restart_done:-false}; then
1142                                 return 0
1143                         fi
1144                         _rc_restart_done=true
1145
1146                         _run_rc_precmd || return 1
1147
1148                         # run those in a subshell to keep global variables
1149                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1150                         ( run_rc_command ${_rc_prefix}start $rc_extra_args )
1151                         _return=$?
1152                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1153
1154                         _run_rc_postcmd
1155                         ;;
1156
1157                 poll)
1158                         _run_rc_precmd || return 1
1159                         if [ -n "$rc_pid" ]; then
1160                                 wait_for_pids $rc_pid
1161                         fi
1162                         _run_rc_postcmd
1163                         ;;
1164
1165                 rcvar)
1166                         echo -n "# $name"
1167                         if [ -n "$desc" ]; then
1168                                 echo " : $desc"
1169                         else
1170                                 echo ""
1171                         fi
1172                         echo "#"
1173                         # Get unique vars in $rcvar $rcvars
1174                         for _v in $rcvar $rcvars; do
1175                                 case $v in
1176                                 $_v\ *|\ *$_v|*\ $_v\ *) ;;
1177                                 *)      v="${v# } $_v" ;;
1178                                 esac
1179                         done
1180
1181                         # Display variables.
1182                         for _v in $v; do
1183                                 if [ -z "$_v" ]; then
1184                                         continue
1185                                 fi
1186
1187                                 eval _desc=\$${_v}_desc
1188                                 eval _defval=\$${_v}_defval
1189                                 _h="-"
1190
1191                                 eval echo \"$_v=\\\"\$$_v\\\"\"
1192                                 # decode multiple lines of _desc
1193                                 while [ -n "$_desc" ]; do
1194                                         case $_desc in
1195                                         *^^*)
1196                                                 echo "# $_h ${_desc%%^^*}"
1197                                                 _desc=${_desc#*^^}
1198                                                 _h=" "
1199                                                 ;;
1200                                         *)
1201                                                 echo "# $_h ${_desc}"
1202                                                 break
1203                                                 ;;
1204                                         esac
1205                                 done
1206                                 echo "#   (default: \"$_defval\")"
1207                         done
1208                         echo ""
1209                         ;;
1210
1211                 *)
1212                         rc_usage $_keywords
1213                         ;;
1214
1215                 esac
1216
1217                 # Apply protect(1) to the PID if ${name}_oomprotect is set.
1218                 case "$rc_arg" in
1219                 start)
1220                         # We cannot use protect(1) inside jails.
1221                         if [ -n "$_oomprotect" ] && [ -f "${PROTECT}" ] &&
1222                             [ "$(sysctl -n security.jail.jailed)" -eq 0 ]; then
1223                                 pid=$(check_process $command)
1224                                 case $_oomprotect in
1225                                 [Aa][Ll][Ll])
1226                                         ${PROTECT} -i -p ${pid}
1227                                         ;;
1228                                 [Yy][Ee][Ss])
1229                                         ${PROTECT} -p ${pid}
1230                                         ;;
1231                                 esac
1232                         fi      
1233                 ;;
1234                 esac
1235
1236                 return $_return
1237         done
1238
1239         echo 1>&2 "$0: unknown directive '$rc_arg'."
1240         rc_usage $_keywords
1241         # not reached
1242 }
1243
1244 #
1245 # Helper functions for run_rc_command: common code.
1246 # They use such global variables besides the exported rc_* ones:
1247 #
1248 #       name           R/W
1249 #       ------------------
1250 #       _precmd         R
1251 #       _postcmd        R
1252 #       _return         W
1253 #
1254 _run_rc_precmd()
1255 {
1256         check_required_before "$rc_arg" || return 1
1257
1258         if [ -n "$_precmd" ]; then
1259                 debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1260                 eval "$_precmd $rc_extra_args"
1261                 _return=$?
1262
1263                 # If precmd failed and force isn't set, request exit.
1264                 if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1265                         return 1
1266                 fi
1267         fi
1268
1269         check_required_after "$rc_arg" || return 1
1270
1271         return 0
1272 }
1273
1274 _run_rc_postcmd()
1275 {
1276         if [ -n "$_postcmd" ]; then
1277                 debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1278                 eval "$_postcmd $rc_extra_args"
1279                 _return=$?
1280         fi
1281         return 0
1282 }
1283
1284 _run_rc_doit()
1285 {
1286         debug "run_rc_command: doit: $*"
1287         eval "$@"
1288         _return=$?
1289
1290         # If command failed and force isn't set, request exit.
1291         if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1292                 return 1
1293         fi
1294
1295         return 0
1296 }
1297
1298 _run_rc_notrunning()
1299 {
1300         local _pidmsg
1301
1302         if [ -n "$pidfile" ]; then
1303                 _pidmsg=" (check $pidfile)."
1304         else
1305                 _pidmsg=
1306         fi
1307         echo 1>&2 "${name} not running?${_pidmsg}"
1308 }
1309
1310 _run_rc_killcmd()
1311 {
1312         local _cmd
1313
1314         _cmd="kill -$1 $rc_pid"
1315         if [ -n "$_user" ]; then
1316                 _cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1317         fi
1318         echo "$_cmd"
1319 }
1320
1321 #
1322 # run_rc_script file arg
1323 #       Start the script `file' with `arg', and correctly handle the
1324 #       return value from the script.
1325 #       If `file' ends with `.sh' and lives in /etc/rc.d, ignore it as it's
1326 #       an old-style startup file.
1327 #       If `file' ends with `.sh' and does not live in /etc/rc.d, it's sourced
1328 #       into the current environment if $rc_fast_and_loose is set; otherwise
1329 #       it is run as a child process.
1330 #       If `file' appears to be a backup or scratch file, ignore it.
1331 #       Otherwise if it is executable run as a child process.
1332 #
1333 run_rc_script()
1334 {
1335         _file=$1
1336         _arg=$2
1337         if [ -z "$_file" -o -z "$_arg" ]; then
1338                 err 3 'USAGE: run_rc_script file arg'
1339         fi
1340
1341         unset   name command command_args command_interpreter \
1342                 extra_commands pidfile procname \
1343                 rcvar rcvars rcvars_obsolete required_dirs required_files \
1344                 required_vars
1345         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1346
1347         case "$_file" in
1348         /etc/rc.d/*.sh)                 # no longer allowed in the base
1349                 warn "Ignoring old-style startup script $_file"
1350                 ;;
1351         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
1352                 warn "Ignoring scratch file $_file"
1353                 ;;
1354         *)                              # run in subshell
1355                 if [ -x $_file ]; then
1356                         if [ -n "$rc_fast_and_loose" ]; then
1357                                 set $_arg; . $_file
1358                         else
1359                                 ( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1360                                   trap "echo Script $_file interrupted >&2 ; exit 1" 2
1361                                   trap "echo Script $_file running >&2" 29
1362                                   set $_arg; . $_file )
1363                         fi
1364                 fi
1365                 ;;
1366         esac
1367 }
1368
1369 #
1370 # load_rc_config [service]
1371 #       Source in the configuration file(s) for a given service.
1372 #       If no service is specified, only the global configuration
1373 #       file(s) will be loaded.
1374 #
1375 load_rc_config()
1376 {
1377         local _name _rcvar_val _var _defval _v _msg _new _d
1378         _name=$1
1379
1380         if ${_rc_conf_loaded:-false}; then
1381                 :
1382         else
1383                 if [ -r /etc/defaults/rc.conf ]; then
1384                         debug "Sourcing /etc/defaults/rc.conf"
1385                         . /etc/defaults/rc.conf
1386                         source_rc_confs
1387                 elif [ -r /etc/rc.conf ]; then
1388                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1389                         . /etc/rc.conf
1390                 fi
1391                 _rc_conf_loaded=true
1392         fi
1393
1394         # If a service name was specified, attempt to load
1395         # service-specific configuration
1396         if [ -n "$_name" ] ; then
1397                 for _d in /etc ${local_startup}; do
1398                         _d=${_d%/rc.d}
1399                         if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1400                                 debug "Sourcing ${_d}/rc.conf.d/$_name"
1401                                 . ${_d}/rc.conf.d/"$_name"
1402                         elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1403                                 local _rc
1404                                 for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1405                                         if [ -f "$_rc" ] ; then
1406                                                 debug "Sourcing $_rc"
1407                                                 . "$_rc"
1408                                         fi
1409                                 done
1410                         fi
1411                 done
1412         fi
1413
1414         # Set defaults if defined.
1415         for _var in $rcvar $rcvars; do
1416                 eval _defval=\$${_var}_defval
1417                 if [ -n "$_defval" ]; then
1418                         eval : \${$_var:=\$${_var}_defval}
1419                 fi
1420         done
1421
1422         # check obsolete rc.conf variables
1423         for _var in $rcvars_obsolete; do
1424                 eval _v=\$$_var
1425                 eval _msg=\$${_var}_obsolete_msg
1426                 eval _new=\$${_var}_newvar
1427                 case $_v in
1428                 "")
1429                         ;;
1430                 *)
1431                         if [ -z "$_new" ]; then
1432                                 _msg="Ignored."
1433                         else
1434                                 eval $_new=\"\$$_var\"
1435                                 if [ -z "$_msg" ]; then
1436                                         _msg="Use \$$_new instead."
1437                                 fi
1438                         fi
1439                         warn "\$$_var is obsolete.  $_msg"
1440                         ;;
1441                 esac
1442         done
1443 }
1444
1445 #
1446 # load_rc_config_var name var
1447 #       Read the rc.conf(5) var for name and set in the
1448 #       current shell, using load_rc_config in a subshell to prevent
1449 #       unwanted side effects from other variable assignments.
1450 #
1451 load_rc_config_var()
1452 {
1453         if [ $# -ne 2 ]; then
1454                 err 3 'USAGE: load_rc_config_var name var'
1455         fi
1456         eval $(eval '(
1457                 load_rc_config '$1' >/dev/null;
1458                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1459                         echo '$2'=\'\''${'$2'}\'\'';
1460                 fi
1461         )' )
1462 }
1463
1464 #
1465 # rc_usage commands
1466 #       Print a usage string for $0, with `commands' being a list of
1467 #       valid commands.
1468 #
1469 rc_usage()
1470 {
1471         echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1472
1473         _sep=
1474         for _elem; do
1475                 echo -n 1>&2 "$_sep$_elem"
1476                 _sep="|"
1477         done
1478         echo 1>&2 ")"
1479         exit 1
1480 }
1481
1482 #
1483 # err exitval message
1484 #       Display message to stderr and log to the syslog, and exit with exitval.
1485 #
1486 err()
1487 {
1488         exitval=$1
1489         shift
1490
1491         if [ -x /usr/bin/logger ]; then
1492                 logger "$0: ERROR: $*"
1493         fi
1494         echo 1>&2 "$0: ERROR: $*"
1495         exit $exitval
1496 }
1497
1498 #
1499 # warn message
1500 #       Display message to stderr and log to the syslog.
1501 #
1502 warn()
1503 {
1504         if [ -x /usr/bin/logger ]; then
1505                 logger "$0: WARNING: $*"
1506         fi
1507         echo 1>&2 "$0: WARNING: $*"
1508 }
1509
1510 #
1511 # info message
1512 #       Display informational message to stdout and log to syslog.
1513 #
1514 info()
1515 {
1516         case ${rc_info} in
1517         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1518                 if [ -x /usr/bin/logger ]; then
1519                         logger "$0: INFO: $*"
1520                 fi
1521                 echo "$0: INFO: $*"
1522                 ;;
1523         esac
1524 }
1525
1526 #
1527 # debug message
1528 #       If debugging is enabled in rc.conf output message to stderr.
1529 #       BEWARE that you don't call any subroutine that itself calls this
1530 #       function.
1531 #
1532 debug()
1533 {
1534         case ${rc_debug} in
1535         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1536                 if [ -x /usr/bin/logger ]; then
1537                         logger "$0: DEBUG: $*"
1538                 fi
1539                 echo 1>&2 "$0: DEBUG: $*"
1540                 ;;
1541         esac
1542 }
1543
1544 #
1545 # backup_file action file cur backup
1546 #       Make a backup copy of `file' into `cur', and save the previous
1547 #       version of `cur' as `backup'.
1548 #
1549 #       The `action' keyword can be one of the following:
1550 #
1551 #       add             `file' is now being backed up (and is possibly
1552 #                       being reentered into the backups system).  `cur'
1553 #                       is created.
1554 #
1555 #       update          `file' has changed and needs to be backed up.
1556 #                       If `cur' exists, it is copied to `back'
1557 #                       and then `file' is copied to `cur'.
1558 #
1559 #       remove          `file' is no longer being tracked by the backups
1560 #                       system.  `cur' is moved `back'.
1561 #
1562 #
1563 backup_file()
1564 {
1565         _action=$1
1566         _file=$2
1567         _cur=$3
1568         _back=$4
1569
1570         case $_action in
1571         add|update)
1572                 if [ -f $_cur ]; then
1573                         cp -p $_cur $_back
1574                 fi
1575                 cp -p $_file $_cur
1576                 chown root:wheel $_cur
1577                 ;;
1578         remove)
1579                 mv -f $_cur $_back
1580                 ;;
1581         esac
1582 }
1583
1584 # make_symlink src link
1585 #       Make a symbolic link 'link' to src from basedir. If the
1586 #       directory in which link is to be created does not exist
1587 #       a warning will be displayed and an error will be returned.
1588 #       Returns 0 on success, 1 otherwise.
1589 #
1590 make_symlink()
1591 {
1592         local src link linkdir _me
1593         src="$1"
1594         link="$2"
1595         linkdir="`dirname $link`"
1596         _me="make_symlink()"
1597
1598         if [ -z "$src" -o -z "$link" ]; then
1599                 warn "$_me: requires two arguments."
1600                 return 1
1601         fi
1602         if [ ! -d "$linkdir" ]; then
1603                 warn "$_me: the directory $linkdir does not exist."
1604                 return 1
1605         fi
1606         if ! ln -sf $src $link; then
1607                 warn "$_me: unable to make a symbolic link from $link to $src"
1608                 return 1
1609         fi
1610         return 0
1611 }
1612
1613 # devfs_rulesets_from_file file
1614 #       Reads a set of devfs commands from file, and creates
1615 #       the specified rulesets with their rules. Returns non-zero
1616 #       if there was an error.
1617 #
1618 devfs_rulesets_from_file()
1619 {
1620         local file _err _me _opts
1621         file="$1"
1622         _me="devfs_rulesets_from_file"
1623         _err=0
1624
1625         if [ -z "$file" ]; then
1626                 warn "$_me: you must specify a file"
1627                 return 1
1628         fi
1629         if [ ! -e "$file" ]; then
1630                 debug "$_me: no such file ($file)"
1631                 return 0
1632         fi
1633
1634         # Disable globbing so that the rule patterns are not expanded
1635         # by accident with matching filesystem entries.
1636         _opts=$-; set -f
1637
1638         debug "reading rulesets from file ($file)"
1639         { while read line
1640         do
1641                 case $line in
1642                 \#*)
1643                         continue
1644                         ;;
1645                 \[*\]*)
1646                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1647                         if [ -z "$rulenum" ]; then
1648                                 warn "$_me: cannot extract rule number ($line)"
1649                                 _err=1
1650                                 break
1651                         fi
1652                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1653                         if [ -z "$rulename" ]; then
1654                                 warn "$_me: cannot extract rule name ($line)"
1655                                 _err=1
1656                                 break;
1657                         fi
1658                         eval $rulename=\$rulenum
1659                         debug "found ruleset: $rulename=$rulenum"
1660                         if ! /sbin/devfs rule -s $rulenum delset; then
1661                                 _err=1
1662                                 break
1663                         fi
1664                         ;;
1665                 *)
1666                         rulecmd="${line%%"\#*"}"
1667                         # evaluate the command incase it includes
1668                         # other rules
1669                         if [ -n "$rulecmd" ]; then
1670                                 debug "adding rule ($rulecmd)"
1671                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1672                                 then
1673                                         _err=1
1674                                         break
1675                                 fi
1676                         fi
1677                         ;;
1678                 esac
1679                 if [ $_err -ne 0 ]; then
1680                         debug "error in $_me"
1681                         break
1682                 fi
1683         done } < $file
1684         case $_opts in *f*) ;; *) set +f ;; esac
1685         return $_err
1686 }
1687
1688 # devfs_init_rulesets
1689 #       Initializes rulesets from configuration files. Returns
1690 #       non-zero if there was an error.
1691 #
1692 devfs_init_rulesets()
1693 {
1694         local file _me
1695         _me="devfs_init_rulesets"
1696
1697         # Go through this only once
1698         if [ -n "$devfs_rulesets_init" ]; then
1699                 debug "$_me: devfs rulesets already initialized"
1700                 return
1701         fi
1702         for file in $devfs_rulesets; do
1703                 if ! devfs_rulesets_from_file $file; then
1704                         warn "$_me: could not read rules from $file"
1705                         return 1
1706                 fi
1707         done
1708         devfs_rulesets_init=1
1709         debug "$_me: devfs rulesets initialized"
1710         return 0
1711 }
1712
1713 # devfs_set_ruleset ruleset [dir]
1714 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1715 #       must be a ruleset name as specified in devfs.rules(5) file.
1716 #       Returns non-zero if it could not set it successfully.
1717 #
1718 devfs_set_ruleset()
1719 {
1720         local devdir rs _me
1721         [ -n "$1" ] && eval rs=\$$1 || rs=
1722         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1723         _me="devfs_set_ruleset"
1724
1725         if [ -z "$rs" ]; then
1726                 warn "$_me: you must specify a ruleset number"
1727                 return 1
1728         fi
1729         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1730         if ! /sbin/devfs $devdir ruleset $rs; then
1731                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1732                 return 1
1733         fi
1734         return 0
1735 }
1736
1737 # devfs_apply_ruleset ruleset [dir]
1738 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1739 #       The ruleset argument must be a ruleset name as specified
1740 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1741 #       if it could not apply the ruleset.
1742 #
1743 devfs_apply_ruleset()
1744 {
1745         local devdir rs _me
1746         [ -n "$1" ] && eval rs=\$$1 || rs=
1747         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1748         _me="devfs_apply_ruleset"
1749
1750         if [ -z "$rs" ]; then
1751                 warn "$_me: you must specify a ruleset"
1752                 return 1
1753         fi
1754         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1755         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1756                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1757                 return 1
1758         fi
1759         return 0
1760 }
1761
1762 # devfs_domount dir [ruleset]
1763 #       Mount devfs on dir. If ruleset is specified it is set
1764 #       on the mount-point. It must also be a ruleset name as specified
1765 #       in a devfs.rules(5) file. Returns 0 on success.
1766 #
1767 devfs_domount()
1768 {
1769         local devdir rs _me
1770         devdir="$1"
1771         [ -n "$2" ] && rs=$2 || rs=
1772         _me="devfs_domount()"
1773
1774         if [ -z "$devdir" ]; then
1775                 warn "$_me: you must specify a mount-point"
1776                 return 1
1777         fi
1778         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1779         if ! mount -t devfs dev "$devdir"; then
1780                 warn "$_me: Unable to mount devfs on $devdir"
1781                 return 1
1782         fi
1783         if [ -n "$rs" ]; then
1784                 devfs_init_rulesets
1785                 devfs_set_ruleset $rs $devdir
1786                 devfs -m $devdir rule applyset
1787         fi
1788         return 0
1789 }
1790
1791 # Provide a function for normalizing the mounting of memory
1792 # filesystems.  This should allow the rest of the code here to remain
1793 # as close as possible between 5-current and 4-stable.
1794 #   $1 = size
1795 #   $2 = mount point
1796 #   $3 = (optional) extra mdmfs flags
1797 mount_md()
1798 {
1799         if [ -n "$3" ]; then
1800                 flags="$3"
1801         fi
1802         /sbin/mdmfs $flags -s $1 ${mfs_type} $2
1803 }
1804
1805 # Code common to scripts that need to load a kernel module
1806 # if it isn't in the kernel yet. Syntax:
1807 #   load_kld [-e regex] [-m module] file
1808 # where -e or -m chooses the way to check if the module
1809 # is already loaded:
1810 #   regex is egrep'd in the output from `kldstat -v',
1811 #   module is passed to `kldstat -m'.
1812 # The default way is as though `-m file' were specified.
1813 load_kld()
1814 {
1815         local _loaded _mod _opt _re
1816
1817         while getopts "e:m:" _opt; do
1818                 case "$_opt" in
1819                 e) _re="$OPTARG" ;;
1820                 m) _mod="$OPTARG" ;;
1821                 *) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1822                 esac
1823         done
1824         shift $(($OPTIND - 1))
1825         if [ $# -ne 1 ]; then
1826                 err 3 'USAGE: load_kld [-e regex] [-m module] file'
1827         fi
1828         _mod=${_mod:-$1}
1829         _loaded=false
1830         if [ -n "$_re" ]; then
1831                 if kldstat -v | egrep -q -e "$_re"; then
1832                         _loaded=true
1833                 fi
1834         else
1835                 if kldstat -q -m "$_mod"; then
1836                         _loaded=true
1837                 fi
1838         fi
1839         if ! $_loaded; then
1840                 if ! kldload "$1"; then
1841                         warn "Unable to load kernel module $1"
1842                         return 1
1843                 else
1844                         info "$1 kernel module loaded."
1845                 fi
1846         else
1847                 debug "load_kld: $1 kernel module already loaded."
1848         fi
1849         return 0
1850 }
1851
1852 # ltr str src dst [var]
1853 #       Change every $src in $str to $dst.
1854 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1855 #       awk(1). If var is non-NULL, set it to the result.
1856 ltr()
1857 {
1858         local _str _src _dst _out _com _var
1859         _str="$1"
1860         _src="$2"
1861         _dst="$3"
1862         _var="$4"
1863         _out=""
1864
1865         local IFS="${_src}"
1866         for _com in ${_str}; do
1867                 if [ -z "${_out}" ]; then
1868                         _out="${_com}"
1869                 else
1870                         _out="${_out}${_dst}${_com}"
1871                 fi
1872         done
1873         if [ -n "${_var}" ]; then
1874                 setvar "${_var}" "${_out}"
1875         else
1876                 echo "${_out}"
1877         fi
1878 }
1879
1880 # Creates a list of providers for GELI encryption.
1881 geli_make_list()
1882 {
1883         local devices devices2
1884         local provider mountpoint type options rest
1885
1886         # Create list of GELI providers from fstab.
1887         while read provider mountpoint type options rest ; do
1888                 case ":${options}" in
1889                 :*noauto*)
1890                         noauto=yes
1891                         ;;
1892                 *)
1893                         noauto=no
1894                         ;;
1895                 esac
1896
1897                 case ":${provider}" in
1898                 :#*)
1899                         continue
1900                         ;;
1901                 *.eli)
1902                         # Skip swap devices.
1903                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1904                                 continue
1905                         fi
1906                         devices="${devices} ${provider}"
1907                         ;;
1908                 esac
1909         done < /etc/fstab
1910
1911         # Append providers from geli_devices.
1912         devices="${devices} ${geli_devices}"
1913
1914         for provider in ${devices}; do
1915                 provider=${provider%.eli}
1916                 provider=${provider#/dev/}
1917                 devices2="${devices2} ${provider}"
1918         done
1919
1920         echo ${devices2}
1921 }
1922
1923 # Originally, root mount hold had to be released before mounting
1924 # the root filesystem.  This delayed the boot, so it was changed
1925 # to only wait if the root device isn't readily available.  This
1926 # can result in rc scripts executing before all the devices - such
1927 # as graid(8), or USB disks - can be accessed.  This function can
1928 # be used to explicitly wait for root mount holds to be released.
1929 root_hold_wait()
1930 {
1931         local wait waited holders
1932
1933         waited=0
1934         while true; do
1935                 holders="$(sysctl -n vfs.root_mount_hold)"
1936                 if [ -z "${holders}" ]; then
1937                         break;
1938                 fi
1939                 if [ ${waited} -eq 0 ]; then
1940                         echo -n "Waiting ${root_hold_delay}s" \
1941                         "for the root mount holders: ${holders}"
1942                 else
1943                         echo -n .
1944                 fi
1945                 if [ ${waited} -ge ${root_hold_delay} ]; then
1946                         echo
1947                         break
1948                 fi
1949                 sleep 1
1950                 waited=$(($waited + 1))
1951         done
1952 }
1953
1954 # Find scripts in local_startup directories that use the old syntax
1955 #
1956 find_local_scripts_old() {
1957         zlist=''
1958         slist=''
1959         for dir in ${local_startup}; do
1960                 if [ -d "${dir}" ]; then
1961                         for file in ${dir}/[0-9]*.sh; do
1962                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1963                                     continue
1964                                 zlist="$zlist $file"
1965                         done
1966                         for file in ${dir}/[!0-9]*.sh; do
1967                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1968                                     continue
1969                                 slist="$slist $file"
1970                         done
1971                 fi
1972         done
1973 }
1974
1975 find_local_scripts_new() {
1976         local_rc=''
1977         for dir in ${local_startup}; do
1978                 if [ -d "${dir}" ]; then
1979                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1980                                 case "$file" in
1981                                 *.sample) ;;
1982                                 *)      if [ -x "$file" ]; then
1983                                                 local_rc="${local_rc} ${file}"
1984                                         fi
1985                                         ;;
1986                                 esac
1987                         done
1988                 fi
1989         done
1990 }
1991
1992 # check_required_{before|after} command
1993 #       Check for things required by the command before and after its precmd,
1994 #       respectively.  The two separate functions are needed because some
1995 #       conditions should prevent precmd from being run while other things
1996 #       depend on precmd having already been run.
1997 #
1998 check_required_before()
1999 {
2000         local _f
2001
2002         case "$1" in
2003         start)
2004                 for _f in $required_vars; do
2005                         if ! checkyesno $_f; then
2006                                 warn "\$${_f} is not enabled."
2007                                 if [ -z "$rc_force" ]; then
2008                                         return 1
2009                                 fi
2010                         fi
2011                 done
2012
2013                 for _f in $required_dirs; do
2014                         if [ ! -d "${_f}/." ]; then
2015                                 warn "${_f} is not a directory."
2016                                 if [ -z "$rc_force" ]; then
2017                                         return 1
2018                                 fi
2019                         fi
2020                 done
2021
2022                 for _f in $required_files; do
2023                         if [ ! -r "${_f}" ]; then
2024                                 warn "${_f} is not readable."
2025                                 if [ -z "$rc_force" ]; then
2026                                         return 1
2027                                 fi
2028                         fi
2029                 done
2030                 ;;
2031         esac
2032
2033         return 0
2034 }
2035
2036 check_required_after()
2037 {
2038         local _f _args
2039
2040         case "$1" in
2041         start)
2042                 for _f in $required_modules; do
2043                         case "${_f}" in
2044                                 *~*)    _args="-e ${_f#*~} ${_f%%~*}" ;;
2045                                 *:*)    _args="-m ${_f#*:} ${_f%%:*}" ;;
2046                                 *)      _args="${_f}" ;;
2047                         esac
2048                         if ! load_kld ${_args}; then
2049                                 if [ -z "$rc_force" ]; then
2050                                         return 1
2051                                 fi
2052                         fi
2053                 done
2054                 ;;
2055         esac
2056
2057         return 0
2058 }
2059
2060 # check_jail mib
2061 #       Return true if security.jail.$mib exists and set to 1.
2062
2063 check_jail()
2064 {
2065         local _mib _v
2066
2067         _mib=$1
2068         if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2069                 case $_v in
2070                 1)      return 0;;
2071                 esac
2072         fi
2073         return 1
2074 }
2075
2076 # check_kern_features mib
2077 #       Return existence of kern.features.* sysctl MIB as true or
2078 #       false.  The result will be cached in $_rc_cache_kern_features_
2079 #       namespace.  "0" means the kern.features.X exists.
2080
2081 check_kern_features()
2082 {
2083         local _v
2084
2085         [ -n "$1" ] || return 1;
2086         eval _v=\$_rc_cache_kern_features_$1
2087         [ -n "$_v" ] && return "$_v";
2088
2089         if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2090                 eval _rc_cache_kern_features_$1=0
2091                 return 0
2092         else
2093                 eval _rc_cache_kern_features_$1=1
2094                 return 1
2095         fi
2096 }
2097
2098 # check_namevarlist var
2099 #       Return "0" if ${name}_var is reserved in rc.subr.
2100
2101 _rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend"
2102 check_namevarlist()
2103 {
2104         local _v
2105
2106         for _v in $_rc_namevarlist; do
2107         case $1 in
2108         $_v)    return 0 ;;
2109         esac
2110         done
2111
2112         return 1
2113 }
2114
2115 # _echoonce var msg mode
2116 #       mode=0: Echo $msg if ${$var} is empty.
2117 #               After doing echo, a string is set to ${$var}.
2118 #
2119 #       mode=1: Echo $msg if ${$var} is a string with non-zero length.
2120 #
2121 _echoonce()
2122 {
2123         local _var _msg _mode
2124         eval _var=\$$1
2125         _msg=$2
2126         _mode=$3
2127
2128         case $_mode in
2129         1)      [ -n "$_var" ] && echo "$_msg" ;;
2130         *)      [ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2131         esac
2132 }
2133
2134 # If the loader env variable rc.debug is set, turn on debugging. rc.conf will
2135 # still override this, but /etc/defaults/rc.conf can't unconditionally set this
2136 # since it would undo what we've done here.
2137 if kenv -q rc.debug > /dev/null ; then
2138         rc_debug=YES
2139 fi